/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlet;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;

import middletier.*;

/**
 *
 * @author gdestri
 */
public class AutenticatoreServlet extends HttpServlet {

    // ATTRIBUTI DAL MODEL (middletier)
    Autenticatore aut = new Autenticatore();
    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        // preleva il parametro in arrivo
        String uname = request.getParameter("txtUsername");
        
        // preleva l'indirizzo del client
        String ipAddClient = request.getRemoteAddr();
        
        // cattura il momento del login in una stringa
        String timestampString = (new Date()).toString();
        
        // verifica username e password
        if (aut.checkUsernameAndPassword(
                        uname,  
                        request.getParameter("txtPassword") ) ) {
                                         
                /* redirezione */
            // crea la sessione
            HttpSession session = request.getSession(true);
        
            // ottiene il sessionID
            String sessionID = session.getId();
            
            // istanzia l'oggetto servlet info, passandogli i parametri
            SessionInfo sessInfo = new SessionInfo(
                    uname, 
                    sessionID, 
                    ipAddClient, 
                    timestampString);
            
            // aggancia alla sessione creata l'oggetto sessInfo
            session.setAttribute("sessInfo", sessInfo);
            
            // ridirige sulla pagina successiva
            response.sendRedirect("/WebAppLogin/LoggedInServlet");
        }
        else {
            // se la password e' sbagliata, ridirige sulla pagina di errore
            response.sendRedirect("/WebAppLogin/ErrorServlet");
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
